###############################################################################
# MessageIndex.pl                                                             #
###############################################################################
#                                                                             #
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
#                                                                             #
# Version:        YaBB 1 Gold - SP 1.3.2                                      #
# Released:       December 2001; Updated August 17, 2004                      #
# Distributed by: http://www.yabbforum.com                                    #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Copyright (c) 2000-2004 YaBB (www.yabbforum.com) - All Rights Reserved.     #
#                                                                             #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
#                                                                             #
###############################################################################

$messageindexplver = "1 Gold - SP 1.3.2";

sub MessageIndex {
	my $start = int( $INFO{'start'} ) || 0;
	my( $bdescrip, $counter, $buffer, $pages, $showmods, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $dlp, $threadlength, $threaddate );
	my( @boardinfo, @threads );
	my( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($currentboard);
	my $maxindex = $INFO{'view'} eq 'all' ? $threadcount : $maxdisplay;

	# Make sure the starting place makes sense.
	if( $start > $threadcount ) { $start = int( $threadcount % $maxindex ) * $maxindex; }
	elsif( $start < 0 ) { $start = 0; }

	# There are three kinds of lies: lies, damned lies, and statistics. 
	# - Mark Twain
	
$yymain .= qq~
	<script language="JavaScript1.2" type="text/javascript">
		function SelPage(pstart) {
			location.href="$cgi;action=messageindex;start="+pstart;
		}
	</script>
~;
	# Construct the page links for this board.
	my($pageindex);
	$start = ( int( $start / $maxindex ) ) * $maxindex;
	$pagenumb = int(($threadcount - 1) / $maxindex) + 1;
	$lastptn = ($pagenumb - 1) * $maxindex;

	if($pagenumb < 2) {
		$pageindex = 1;
	}
	else {
		$startpage = 0;
		$prevpage = $start - $maxindex;
		$nextpage = $start + $maxindex;
		$pageindex .= qq~$pagenumb ~;
		if($start < $maxindex) { $pageindex .= qq~<img src="$imagesdir/none.gif" height="20" width="20" border="0" alt="" vspace="0" hspace="0" align="absmiddle">~; }
		else { $pageindex .= qq~<a href="$cgi;action=messageindex;start=$prevpage"><img src="$imagesdir/prev.gif" height="20" width="20" border="0" alt="" vspace="0" hspace="0" align="absmiddle"></a>~; }
		$pageindex .= qq~<form style="display: inline" method="POST"><select class="catbg" style="width: 50px; font-size: 12px; margin: 0px; padding: 0px; border: 0px" onchange="if(this.options[this.selectedIndex].value) SelPage(this.options[this.selectedIndex].value)">~;
		for($i=1; $i<=$pagenumb; $i++) {
			$selected = "";
			if($start == $startpage) { $selected = " selected" }
			$pageindex .= qq~<option value="$startpage"$selected>$i</option>~;
			$startpage += $maxindex;
		}
		$pageindex .= qq~</select></form>~;
		if($start >= $lastptn) { $pageindex .= qq~<img src="$imagesdir/none.gif" height="20" width="20" border="0" alt="" vspace="0" hspace="0" align="absmiddle">~; }
		else { $pageindex .= qq~<a href="$cgi;action=messageindex;start=$nextpage"><img src="$imagesdir/next.gif" border="0" height="20" width="20" alt="" vspace="0" hspace="0" align="absmiddle"></a>~; }
	}


	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$cat = <FILE>;
	fclose(FILE);
	fopen(FILE, "$boardsdir/$cat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$currcat = $cat;
	$cat = <FILE>;
	fclose(FILE);

	# Get the board's description
	fopen(FILE, "$boardsdir/$currentboard.dat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.dat");
	@boardinfo = <FILE>;
	fclose(FILE);
	chomp @boardinfo;
	$bdescrip = $boardinfo[1];

	# Open and quickly read the current board thread list.
	# Skip past threads until we reach the "page" we want.
	fopen(FILE, "$boardsdir/$currentboard.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.txt");
	@threadlist = <FILE>;
	$threadcount = $#threadlist;
	@threadlist2 = '';
	fclose(FILE);

	# Sticky Threads
	fopen(FILE, "$boardsdir/sticky.stk") || &fatal_error("300 $txt{'106'}: $txt{'23'} sticky.stk");
	@stickys = <FILE>;
	$stickycount = $#stickys;
	fclose(FILE);
	for ($i=0; $i<=$threadcount; $i++) {
		($mnum) = split( /\|/, $threadlist[$i] );
		$l = 0;
		$is = 0;
		foreach $curnum (@stickys) {
			if ($mnum == $curnum) {
				$is = 1;
				$stickylist{$l} = $threadlist[$i];
				#splice(@threadlist,$i,1);
				last;
			}
			$l++;
		}
		if ($is == 0) { push(@threadlist2,$threadlist[$i]); }
	}
	if (!($threadlist2[0])) { shift(@threadlist2); }

	#now sort the stickys
	@stickylist2 = sort {$b <=> $a } keys %stickylist;
	for ($i=0; $i<=$stickycount; $i++) {
		chomp $stickylist{$i};
		if ($stickylist{$i}) { unshift(@threadlist2,"$stickylist{$i}\n"); }
	}

	$counter = 0;
	$tmpa = '';
	if($counter < $start && ($buffer = $threadlist2[$counter])) {
		$tmpa = $buffer;
		$counter++;
	}
	while($counter < $start && ($buffer = $threadlist2[$counter])) { $counter++; }

	$#threads = $maxindex - 1;
	$curln = $counter;
	$counter = 0;
	while( $counter < $maxindex && ( $buffer = $threadlist2[$curln+$counter] ) ) {
		chomp $buffer;
		$threads[$counter] = $buffer;
		$counter++;
	}
	$#threads = $counter - 1;

	# Let's get the info for the first thread in this forum.
	$tmpa ||= $threads[0];
	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split( /\|/, $tmpa );

	# Mark current board as seen.
	&dumplog($currentboard);

	# Build a list of the board's moderators.
	if( scalar keys %moderators > 0 ) {
		if( scalar keys %moderators == 1 ) { $showmods = qq~($txt{'298'}: ~; }
		else { $showmods = qq~($txt{'299'}: ~; }
		while( $_ = each(%moderators) ) {
			&FormatUserName($_);
			$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$_}" class="nav">$moderators{$_}</a>, ~;
		}
		$showmods =~ s/, \Z/)/;
	}

	$notify = '';
	# Update notification file that the board has been viewed.
	if($enable_board_notify && $username ne 'Guest') {
		$notify = qq~$menusep<a href="$cgi;action=notify2" onclick="javascript:return confirm('$bln_txt{'03'}')" class="altlink">$img{'notify_b'}</a>~;
		if(-e("$boardsdir/$currentboard.mail"))  {
			my $i = 0;
			my $found = 0;
			fopen(FILE, "$boardsdir/$currentboard.mail");
			@mails = <FILE>;
			fclose(FILE);
			foreach $curmail (@mails) {
				chomp $curmail;
				($curmail, $mail_sent, $notify_type) = split(/\|/,$curmail);
				if ($curmail eq $settings[2]) {
					$notify = qq~$menusep<a href="$cgi;action=notify3" onclick="javascript:return confirm('$bln_txt{'04'}')" class="altlink">$img{'notify_b'}</a>~;
					if ($mail_sent == 1) {$mail_sent = 0; $found = 1;}
				}
				$mails[$i] = "$curmail|$mail_sent|$notify_type\n";
				$i++;
			}
			if ($found == 1) {
				fopen(FILE, ">$boardsdir/$currentboard.mail");
				print FILE @mails;
				fclose(FILE);
			}
		}
	}

	# Load censor list.
	fopen(FILE,"$vardir/censor.txt");
	while( chomp( $buffer = <FILE> ) ) {
		($tmpa,$tmpb) = split(/=/,$buffer);
		push(@censored,[$tmpa,$tmpb]);
	}
	fclose(FILE);

	# Print the header and board info.
	$curboardurl = $curposlinks ? qq~<a href="$cgi" class="nav">$boardname</a>~ : $boardname;
	$yymain .= qq~
<table width="100%" cellpadding="0" cellspacing="0">
  <tr>
    <td><font size="2" class="nav"><b>
    <IMG SRC="$imagesdir/open.gif" BORDER=0>
    <a href="$scripturl" class="nav">$mbname</a><br>
    <IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>
    <a href="$scripturl#$currcat" class="nav">$cat</a><br>
    <IMG SRC="$imagesdir/tline2.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>
    $curboardurl</b> <font size="1">$showmods</font></font></td>
  </tr>
</table>
~;
if($ShowBDescrip && $bdescrip ne "") {
$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td width="100%"><font size="1">$bdescrip</font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
}
$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size=2><b>$txt{'139'}:</b> $pageindex</font></td>
	    <td class="catbg" bgcolor="$color{'catbg'}" align=right nowrap><font size=-1>
~;
	if ($username ne 'Guest') {
if($showmarkread) {
	$yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~;
}
if($enable_board_notify) {
	$yymain .= $notify;
}
}
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>
	    </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
~;
if($autoapplyrate{$currentboard} == 1 && $viewrateindex{$currentboard} == 1) {
	$yymain .= qq~
      <tr>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="10%" colspan="2"><font size="2">&nbsp;</font></td>
	~;
	if($rategraph{$currentboard} == 1) {
		$yymain .= qq~<td class="titlebg" bgcolor="$color{'titlebg'}" width="32%"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'70'}</b></font></td>~;
	}
	else {
		$yymain .= qq~<td class="titlebg" bgcolor="$color{'titlebg'}" width="25%"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'70'}</b></font></td>~;
	}
	$yymain .= qq~
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="12%" align="center"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'109'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'110'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'301'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="19%"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'111'}</b></font></td>
	~;
	if($rategraph{$currentboard} == 1) {
		$yymain .= qq~<td class="titlebg" bgcolor="$color{'titlebg'}" width="16%" align="center"><font size="2" class="text1" color="$color{'titletext'}"><b>$mbcrate{'04'}</b></font></td>~;
	}
	else {
		$yymain .= qq~<td class="titlebg" bgcolor="$color{'titlebg'}" width="23%" align="center"><font size="2" class="text1" color="$color{'titletext'}"><b>$mbcrate{'04'}</b></font></td>~;
	}
	$yymain .= qq~
      </tr>
	~;
}
else {
	$yymain .= qq~
      <tr>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="10%" colspan="2"><font size="2">&nbsp;</font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="44%"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'70'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="14%" align="center"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'109'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'110'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'301'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'111'}</b></font></td>
      </tr>
	~;
}
	$yymain .= qq~
~;

	# Begin printing the message index for current board.
	$counter = $start;
	foreach( @threads ) {
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split( /\|/, $_ );
		# Set thread class depending on locked status and number of replies.
		$threadclass = 'thread';
		if( $mstate == 1 ) { $threadclass = 'locked'; }
		elsif( $mreplies > 24 ) { $threadclass = 'veryhotthread'; }
		elsif( $mreplies > 14 ) { $threadclass = 'hotthread'; }
		elsif( $mstate == 0 ) { $threadclass = 'thread'; }
		foreach $curnum (@stickys) {
			if ($mnum == $curnum) {
				if($threadclass eq 'locked') { $threadclass = 'stickylock'; }
				else { $threadclass = 'sticky'; }
			}
		}

		# Decide if thread should have the "NEW" indicator next to it.
		# Do this by reading the user's log for last read time on thread,
		# and compare to the last post time on the thread.
		## LAST READ MOD ##
		$stuff = e"tlog($mnum);
		($dlp, $lastread) = split( /\|/, $stuff );
		if ($lastread ne '') { $lastread = qq~;start=$lastread#$lastread~;}
		## /LAST READ MOD ##
		$threaddate = stringtotime($mdate);
		if( $max_log_days_old && $dlp < $threaddate && $username ne 'Guest' && e"tlog("$currentboard--mark") < $threaddate ) {
			## LAST READ MOD ##
			$new = qq~<a href="$cgi;action=display;num=$mnum$lastread"><img src="$imagesdir/new.gif" border="0" alt="$txt{'302a'}"></a>~; 
			## /LAST READ MOD ##
		}
		else { $new = ''; }

		# Load the current nickname of the account name of the thread starter.
		if( $musername ne 'Guest' && -e "$memberdir/$musername.dat" ) {
			&LoadUser($musername);
			$mname = $userprofile{$musername}->[1] || $mname || $txt{'470'};
			$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$mname</a>~;
		}
		else {
			$mname ||= $txt{'470'};
		}

		# Censor the subject of the thread.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}

		# Decide how many pages the thread should have.
		$threadlength = $mreplies + 1;
		$pages = '';
		if( $threadlength > $maxmessagedisplay ) {
			$tmpa = 1;
			for( $tmpb = 0; $tmpb < $threadlength; $tmpb += $maxmessagedisplay ) {
				$pages .= qq~<a href="$cgi;action=display;num=$mnum;start=$tmpb#$tmpb">$tmpa</a>\n~;
				++$tmpa;
			}
			$pages =~ s/\n\Z//;
			$pages = qq~<BR><font size="1"> $txt{'139'} $pages <A href="$cgi;action=display;num=$mnum;start=all">$pidtxt{'01'}</a> </font>~;
		}

		if( fopen(FILE, "$datadir/$mnum.data") ) {
			$tmpa = <FILE>;
			fclose(FILE);
		}
		elsif( -e "$datadir/$mnum.data" ) {
			&fatal_error("301 $txt{'106'}: $txt{'23'} $mnum.data");
		}
		else {
			$tmpa = '0';
		}


		($views, $lastposter) = split(/\|/, $tmpa);
		if( $lastposter =~ m~\AGuest-(.*)~ ) {
			$lastposter = $1;
		}
		else {
			unless( $lastposter eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			&LoadUser($lastposterid);
		}
		$lastpostername = $lastposter || $txt{'470'};
		$views = $views ? $views - 1 : 0;

	if(!-e ("$vardir/$mnum.rate") && $autoapplyrate{$currentboard} == 1) {
		if(!-e ("$vardir/rateslist.txt")) {
			fopen(FILE, ">$vardir/rateslist.txt", 1);
			print FILE "|1|1|1\n";
			fclose(FILE);
		}

		fopen(FILE, "$vardir/rateslist.txt");
		@ratelist = <FILE>;
		$listnum = @ratelist;
		fclose(FILE);

		$namestart = "";
		$namestart .= qq($msub|$date);
		$ratelink = qq~$scripturl?board=$currentboard;action=display;num=$mnum~;

		fopen( FILE, ">$vardir/$mnum.rate", 1);
		print FILE "$boardname\n";
		print FILE "$namestart\n";
		print FILE "\n";
		print FILE "0.00|0\n";
		print FILE "$ratelink\n";
		fclose(FILE);

		fopen(FILE, ">$vardir/rateslist.txt", 1);
		foreach $currate (@ratelist) {
			chomp $currate;
			print FILE "$currate\n";
		}
		print FILE "$viewnum|$username\n";
		fclose(FILE);
	}
	if($autoapplyrate{$currentboard} == 1 && $viewrateindex{$currentboard} == 1) {
		@rateinfo = ();
		fopen(RATEFILEREAD,"$vardir/$mnum.rate");
		@rateinfo = <RATEFILEREAD>;
		$lines = @rateinfo;
		fclose(RATEFILEREAD);
		chomp @rateinfo;
		$raters = $lines - 5;
		($rating, $clicks) = split(/\|/,$rateinfo[3]);
		if($rating == 0) { $rating = "0.00" }
		$barrate = $rating * 10;
		$ratebar = "";
		$ratebar1 = "";
		$ratebar2 = "";
		$barchart = int($barrate);

		$ratebar2 .= qq~<table width="100%" align="center" border="0" cellpadding="2" cellspacing="0"><tr>~;
		if($rategraph{$currentboard} == 1) {

		if($ratestar{$currentboard} == 1) {
			if($barchart < 10) { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st00.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
			elsif($barchart < 30) { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st01.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
			elsif($barchart < 50) { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st02.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
			elsif($barchart < 70) { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st03.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
			elsif($barchart < 90) { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st04.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
			else { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st05.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
		}
		else {
			$barchart1 = 100 - $barchart;
			if ($barchart < 1) {$ratebar = "$ratebar";}
			else {
				$ratebar = qq~<img src="$imagesdir/ratebar.gif" width="$barchart" height="10" alt="" border="0" align="absmiddle">~;
			}
			if ($barchart > 99) {$ratebar1 = "$ratebar1";}
			else {
				$ratebar1 = qq~<img src="$imagesdir/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" align="absmiddle">~;
			}
			$ratebar2 .= qq~<td align="left"><a href="$cgi;action=setoverview;rateid=$mnum">$ratebar$ratebar1</a></font></td>~;
		}

		}
		else {

		if($ratestar{$currentboard} == 1) {
			if($barchart < 10) { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st00.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
			elsif($barchart < 30) { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st01.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
			elsif($barchart < 50) { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st02.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
			elsif($barchart < 70) { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st03.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
			elsif($barchart < 90) { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st04.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
			else { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st05.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
		}
		else {
			$barchart1 = 100 - $barchart;
			if ($barchart < 1) {$ratebar = "$ratebar";}
			else {
				$ratebar = qq~<img src="$imagesdir/ratebar.gif" width="$barchart" height="10" alt="" border="0" align="absmiddle">~;
			}
			if ($barchart > 99) {$ratebar1 = "$ratebar1";}
			else {
				$ratebar1 = qq~<img src="$imagesdir/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" align="absmiddle">~;
			}
			$ratebar2 .= qq~<td width="24%" align="right"><font size="1">$rating</td><td align="left"><a href="$cgi;action=setoverview;rateid=$mnum">$ratebar$ratebar1</a></font></td>~;
		}

		}

		$ratebar2 .= qq~</tr></table>~;
	}

		# Print the thread info.
		$mydate = &timeformat($mdate);
		$yymain .= qq~
~;
if($autoapplyrate{$currentboard} == 1 && $viewrateindex{$currentboard} == 1) {
	$yymain .= qq~
      <tr>
        <td class="windowbg2" valign="middle" align="center" width="6%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$threadclass.gif"></td>
        <td class="windowbg2" valign="middle" align="center" width="4%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$micon.gif" alt="" border="0" align="middle"></td>
        <td class="windowbg" valign="middle" width="28%" bgcolor="$color{'windowbg'}"><font size="2">$new <a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages</font></td>
        <td class="windowbg2" valign="middle" align="center" width="12%" bgcolor="$color{'windowbg2'}"><font size="1">$mname</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size="2">$mreplies</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size="2">$views</font></td>
        <td class="windowbg2" valign="middle" bgcolor="$color{'windowbg2'}"><font size="1">$mydate<br>$txt{'525'} $lastpostername</font></td>
        <td class="windowbg2" align="center" valign="middle" bgcolor="$color{'windowbg2'}">$ratebar2</td>
      </tr>
	~;
}
else {
	$yymain .= qq~
      <tr>
        <td class="windowbg2" valign="middle" align="center" width="6%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$threadclass.gif"></td>
        <td class="windowbg2" valign="middle" align="center" width="4%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$micon.gif" alt="" border="0" align="middle"></td>
       <td class="windowbg" valign="middle" width="44%" bgcolor="$color{'windowbg'} rowspan="2" onMouseOver="this.style.backgroundColor='$hover{'cellhoverm'}'; this.style.cursor='hand';" onmouseout="this.style.backgroundColor='$hover{'windowbg2'}';""$curboardname'""><font size="2">$new<a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages</font></td>
        <td class="windowbg2" valign="middle" align="center" width="14%" bgcolor="$color{'windowbg2'}" onmouseover="this.style.backgroundColor='$hover{'cellhoverm'}'; this.style.cursor='hand';" onmouseout="this.style.backgroundColor='$hover{'windowbg2'}';" ><font size="1">$mname</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size="2">$mreplies</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size="2">$views</font></td>
        <td class="windowbg2" valign="middle" width="24%" bgcolor="$color{'windowbg2'}" onmouseover="this.style.backgroundColor='$hover{'cellhoverm'}'; this.style.cursor='hand';" onmouseout="this.style.backgroundColor='$hover{'windowbg2'}';" ><font size="1">$mydate<br>$txt{'525'} $lastpostername</font></td>
      </tr>
	~;
}
	$yymain .= qq~
~;
		++$counter;
	}

	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size=2><b>$txt{'139'}:</b> $pageindex</font></td>
	    <td class="catbg" bgcolor="$color{'catbg'}" align=right nowrap><font size="2">
~;
	if ($username ne 'Guest') {
	if($showmarkread) { $yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~; }
	if($enable_board_notify) { $yymain .= $notify; }
}
	&jumpto;
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>
	    </font></td>
	  </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table><br>
<table cellpadding=0 cellspacing=0 width="100%">
  <tr>
	<td align="left" valign="middle"><font size="1">
	<img src="$imagesdir/thread.gif"> $txt{'457'}<BR>
	<img src="$imagesdir/hotthread.gif"> $txt{'454'}<BR>
	<img src="$imagesdir/veryhotthread.gif"> $txt{'455'}
	</font></td><td align="left" valign="middle"><font size="1">
	<img src="$imagesdir/locked.gif"> $txt{'456'}<BR>
	<img src="$imagesdir/sticky.gif"> $txt{'779'}<BR>
	<img src="$imagesdir/stickylock.gif"> $txt{'780'}
	</font></td>
	<td align="right" valign="middle"><font size="1">$selecthtml</font></td>
  </tr>
</table>
~;
### Quick Reply Box 1.3b ###

	### MBCO2 Post access check ###
	if ($start_users{$currentboard} || $start_groups{$currentboard}) {
		my $access = &AccessCheck($currentboard, 1) || "";
		if ($access eq "denied") {$enable_quickpost = 0;}
	}
	### MBCO2 Post access check ###

	if ($username ne "Guest" && $enable_quickpost == 1) {
$yymain .= qq~
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<form action="$cgi;action=post2" method="post" name="postmodify" onsubmit="postmodify.post.disabled=true; postmodify.clear.disabled=true;">
<input type="hidden" name="threadid" value="">
<input type="hidden" name="icon" value="xx">
<table border=0 width="80%" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td align="center" class="titlebg" bgcolor="$color{'titlebg'}"><font size="2" class="text1" color="$color{'titletext'}"><b>$qrb_txt{'1'}</b></font></td>
  </tr>
  <tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
      <table width="100%" cellpadding="4" cellspacing="0">
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$txt{'70'}:</b></font></td>
          <td><font size="2"><input type="text" name="subject" value="" size="40" style="width:100%"></td>
        </tr>~;

	### Add More Smilies 3.0 - Smiley List ###
	if ($enable_quicksmilies == 1) {
		if ($SmilieURL[0] eq "") {&LoadSmilies;}

		$showmore = 0; 
		$smilie_list = "";
		$smilie_more = "";
		for( my $i = 0; $i < @SmilieURL; $i++ ) {
			if ($SmilieURL[$i] =~ /\//i) {$tmpurl = $SmilieURL[$i];} else {$tmpurl = qq~$smiliesurl/$SmilieURL[$i]~;}
			($tmpCode, $dummy) = split (/\s+/, $SmilieCode[$i]); 
			$tmpCode =~ s/'/'/g;
			if ($SmilieOption[$i] % 2 == 1) { $smilie_list .= qq~
                    document.write("<img src='$tmpurl' onclick='javascript:AddText(" + '" $tmpCode"' + ")' align='bottom' alt='$SmilieDescription[$i]' border='0' style='cursor:hand'> ");~;
			}
			if (int($SmilieOption[$i] / 4) % 2 == 1) {$showmore = 1;}
		}

		if ($showmore) {$smilie_more = qq~
                    document.write('<a href="$scripturl?action=smilieindex" target="_blank" onclick="' + "javascript: window.open('$scripturl?action=smilieindex', 'list', ',','width=100,height=100,left=0,top=0,scrollbars=yes'); return false" + '">$smi_txt{'8'}</a>');~;
		}

		if ($smilie_list ne "" || $smilie_more ne "" ) {$yymain .= qq~
              <tr>
                <td width="23%"><font size="2"><b>$txt{'297'}:</b></font></td>
                <td valign="middle">
                  <script language="JavaScript1.2" type="text/javascript">
                  <!--
                  if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {$smilie_list$smilie_more
                  }
                  else { document.write("<font size='1'>$txt{'215'}</font>"); }
                  //-->
                  </script>
                  <noscript>
                    <font size="1">$txt{'215'}</font>
                  </noscript>
                </td>
              </tr>~;
		}
	}
	### Add More Smilies 3.0 - Smiley List ###

	$yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$txt{'72'}:</b></font></td>
          <td><textarea name="message" rows="5" cols="60" wrap="soft" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" style="width:100%"></textarea></td>
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td align="center" class="catbg" bgcolor="$color{'catbg'}"><input type="submit" name="post" value="$txt{'105'}" accesskey="s">  <input type="reset" name="clear" value="$txt{'278'}" accesskey="r"></td>
  </tr>
</table>
</form>
~;
	}

### Quick Reply Box 1.3b ###

	$yytitle = $boardname;
	&template;
	exit;
}

sub MarkRead {
	# Mark all threads in this board as read.
	&dumplog("$currentboard--mark");
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
}

1;